"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGTraitDescriptionStrategy subclass:#RGMetaclassTraitStrategy
	instanceVariableNames:'baseTrait'
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGMetaclassTraitStrategy comment:''
!

!RGMetaclassTraitStrategy methodsFor:'private - backend access'!

baseBehavior

    ^ self baseTrait
!

baseTrait

    ^ self backend forBehavior metaclassTraitBaseTraitFor: self owner
!

baseTrait: anRGClass

    self backend forBehavior setMetaclassTraitBaseTraitFor: self to: anRGClass
!

category

    ^ self baseTrait category
!

comment

    ^ self baseTrait comment
!

definition
    ^String streamContents: [:stream |
        stream
            nextPutAll: self baseTrait name;
            nextPutAll: ' clasTrait';
            crtab;
            nextPutAll: 'uses: ';
            nextPutAll: self owner traitCompositionString]
!

instanceSide

    ^ self baseTrait
!

isMeta

    ^true
!

isMetaclassTrait

    ^ true
!

makeResolved

    
    "try to set the correct name before resolving of it"
    ((self owner hasUnresolved: #name) and: [ self baseClass isRingResolved and: [ self baseTrait hasResolvedName] ]) ifTrue: [ 
        self owner pvtName: (self baseTrait name, ' classTrait') asSymbol.
         ].

    super makeResolved.
    
    baseTrait := self baseTrait markAsRingResolved.
!

package

    ^ self baseTrait package
!

pvtBaseTrait

    ^ baseTrait value
!

pvtBaseTrait: anRGTrait

    self owner environment verifyOwnership: anRGTrait.

    ^ baseTrait := anRGTrait
!

pvtResolvableProperties

    ^ super pvtResolvableProperties, {
        #baseTrait -> baseTrait. 
   	}
    
    
!

referencedBehaviors

    ^ super referencedBehaviors, {self baseTrait}
!

sibling

    ^ self baseTrait.
!

theNonMetaClass
    ^self baseTrait
!

traitTransformationString		
        
    ^ self owner name 
! !

!RGMetaclassTraitStrategy methodsFor:'testing'!

isMetaclassTraitStrategy

    ^ true
!

storeName

    ^ 'RGMetaclassTrait'
! !

!RGMetaclassTraitStrategy methodsFor:'visiting'!

acceptVisitor: aVisitor 

    ^ aVisitor visitClassTrait: self owner
! !

