"
COPYRIGHT (c) 2020 LabWare
"
"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGTraitV2DescriptionStrategy subclass:#RGMetaclassTraitV2Strategy
	instanceVariableNames:'baseClass'
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGMetaclassTraitV2Strategy comment:''
!

!RGMetaclassTraitV2Strategy class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2020 LabWare

"
! !

!RGMetaclassTraitV2Strategy methodsFor:'error handling'!

definition
    ^String streamContents: [:stream |
        stream
            nextPutAll: self baseTrait name;
            nextPutAll: ' clasTrait';
            crtab;
            nextPutAll: 'uses: ';
            nextPutAll: self owner traitCompositionString.
        (self owner slots size > 0) ifTrue: [ 
            (self owner slotsNeedFullDefinition or: [ ClassDefinitionPrinter showFluidClassDefinition ])
                ifFalse: [  
                            stream
                                crtab;
                                nextPutAll: 'instanceVariableNames: ';
                                store: self owner instanceVariablesString]
                ifTrue: [ 
                            stream
                                crtab;
                                nextPutAll: 'slots: ';
                                nextPutAll: self owner slotDefinitionString]]]
! !

!RGMetaclassTraitV2Strategy methodsFor:'private - backend access'!

baseBehavior

    ^ self baseClass
!

baseClass

    ^ self backend forBehavior baseClassFor: self owner
!

baseClass: anRGClass

    self backend forBehavior setBaseClassFor: self owner to: anRGClass
!

bindingOf: varName
    
    ^ self baseClass bindingOf: varName
!

category

    ^ self baseClass category
!

classSide

    ^ self owner
!

classVarNames

    ^ self theNonMetaClass classVarNames
!

comment

    ^ self baseClass comment
!

defaultMetaClass

    "will be set correctly together with baseClass"
    ^ RGUnresolvedValue new default: nil.
!

initialize

    baseClass := RGUnresolvedValue recursive.
    
    super initialize.
    
    
!

instanceSide
    ^ self baseClass 
!

isMeta

    ^true
!

isMetaclass

    ^true
!

makeResolved

    "try to set the correct name before resolving of it"
    ((self owner hasUnresolved: #name) and: [ self baseClass isRingResolved and: [ self baseClass hasResolvedName ] ]) ifTrue: [ 
        self owner pvtName: (self baseClass name, ' class') asSymbol.
         ].
    
    super makeResolved.
    
    baseClass := self baseClass markAsRingResolved.
!

metaclass

    "temporary" 
    ^ self
!

package

    ^ self baseClass package
!

pvtAsMetaclassTrait

    | newMetaclassTrait |
    
    (self owner resolvedProperties includesAnyOf: #(superclass traitComposition))
        ifTrue: [self error: 'This class cannot be converted to trait'].
        
    "TODO: check empty layout"
    newMetaclassTrait := RGMetaclassTrait unresolvedWithParent: self owner parent.
    newMetaclassTrait copyPropertiesFrom: self owner.

    (self owner hasResolvedName)
        ifTrue: [ newMetaclassTrait pvtName: ((self owner name withoutSuffix: ' class'), ' classTrait') asSymbol ].
    newMetaclassTrait pvtLocalMethods: self owner localMethods.
    
    ^ newMetaclassTrait
    
    
!

pvtBaseClass

    ^ baseClass value
!

pvtBaseClass: anRGClass

    self owner environment verifyOwnership: anRGClass.

    ^ baseClass := anRGClass
!

pvtResolvableProperties

    ^ super pvtResolvableProperties, { 
        #baseClass -> baseClass. 
   	}
    
    
!

referencedBehaviors

    ^ super referencedBehaviors, {self baseClass}
!

sibling

    ^ self baseClass.
!

theNonMetaClass
    ^self baseClass
! !

!RGMetaclassTraitV2Strategy methodsFor:'testing'!

isMetaclassStrategy

    ^ true
!

storeName

    ^ 'RGMetaclass'
! !

