"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGBehaviorStrategy subclass:#RGTraitDescriptionStrategy
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGTraitDescriptionStrategy comment:''
!

!RGTraitDescriptionStrategy methodsFor:'variables'!

allSharedPoolNames

    ^#()
!

initialize

    super initialize.
    
    self owner environment backend createUnresolvedTraitGroupFor: self owner.
    
!

isTrait

    ^true
!

methods

    | allMethods |
    allMethods := IdentitySet new.
    self localMethodsDo: [ :each | allMethods add: each].
    ^ allMethods asArray
!

name: aString

    | usersWithOldDefinition |

    usersWithOldDefinition := self users collect: [ :each | 
        each -> each copyForBehaviorDefinition ].

    super name: aString.
    
    usersWithOldDefinition do: [ :assoc |
        self announcer behaviorDefinitionChangedFrom: assoc value to: assoc key.
        self announcer behaviorModificationAppliedTo: assoc key. ].		
!

trait

    ^ self owner
!

users
    
    "return collection of user of the trait"

    | result |
    
    result := IdentitySet new.

    self environment ask behaviorsDo: [ :each |
        (each usedTraits includes: self) ifTrue: [ result add: each ] ].
    
    ^ result.
! !

