"{ Package: 'stx:goodies/ring/core/tests' }"

"{ NameSpace: Smalltalk }"

RGTest subclass:#RGLayoutDefinitionTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Tests-Core'
!

RGLayoutDefinitionTest comment:''
!

!RGLayoutDefinitionTest methodsFor:'tests'!

testImplicitEnvironment
    
    RGLayout allSubclasses do: [ :layoutClass |
        | layout | 
        layout  := layoutClass unnamed.
        self checkImplicitSingleClassEnvironmentOf: layout parent. ].	

!

testIsBitsLayout

    self assert: (RGByteLayout unnamed isBitsLayout).
    self assert: (RGWordLayout unnamed isBitsLayout).
    self assert: (RGCompiledMethodLayout unnamed isBitsLayout).
    self deny: (RGFixedLayout unnamed isBitsLayout).
    
!

testIsBytesLayout

    self assert: (RGByteLayout unnamed isByteLayout).
    self assert: (RGCompiledMethodLayout unnamed isByteLayout).
    self deny: (RGFixedLayout unnamed isByteLayout).
    
!

testIsCompiledMethodLayout

    self assert: (RGCompiledMethodLayout unnamed isCompiledMethodLayout).
    self deny: (RGFixedLayout unnamed isCompiledMethodLayout).
    
!

testIsEmptyLayout

    | layout layoutClass | 
        
    layoutClass := 	RGEmptyLayout.
    layout  := layoutClass unnamed.
    self assert: (layout isEmptyLayout).
    (RGLayout allSubclasses copyWithout: layoutClass) do: [ :each |
        self deny: (each unnamed isEmptyLayout) ]
    
!

testIsEphemeronLayout

    self assert: (RGEphemeronLayout unnamed isEphemeronLayout).
    self deny: (RGFixedLayout unnamed isEphemeronLayout).
    
!

testIsFixedLayout

    self assert: (RGFixedLayout unnamed isFixedLayout).
    self deny: (RGWordLayout unnamed isFixedLayout).
    
!

testIsImmediateLayout

    self assert: (RGImmediateLayout unnamed isImmediateLayout).
    self deny: (RGFixedLayout unnamed isImmediateLayout).
    
!

testIsObjectLayout

    self assert: (RGImmediateLayout unnamed isObjectLayout).
    self deny: (RGEmptyLayout unnamed isObjectLayout).
    
!

testIsPointerLayout

    self assert: (RGFixedLayout unnamed isPointerLayout).
    self deny: (RGEmptyLayout unnamed isPointerLayout).
    
!

testIsVariableLayout

    self assert: (RGVariableLayout unnamed isVariableLayout).
    self assert: (RGBitsLayout unnamed isVariableLayout).
    self deny: (RGFixedLayout unnamed isVariableLayout).
    self assert: (RGCompiledMethodLayout unnamed isVariableLayout).
    
!

testIsWeakLayout

    self assert: (RGWeakLayout unnamed isWeakLayout).
    self deny: (RGEmptyLayout unnamed isWeakLayout).
    
!

testIsWordLayouts

    self assert: (RGWordLayout unnamed isWordLayout).
    self deny: (RGEmptyLayout unnamed isWordLayout).
    
!

testNewLayouts

    RGLayout allSubclasses do: [ :layoutClass |
        | layout | 
        layout  := layoutClass unnamed.
        self assert: (layout isRingResolved).
        self assert: (layout hasUnresolved: #name).
        self assert: (layout isLayout).
        self assert: (layout allSlots isEmpty).
        self assert: (layout instVarNames isEmpty). ]
!

testResolvingConsistency

    | anObject |
    anObject := RGPointerLayout unnamed.
    self checkClassesConsistency: anObject and: anObject makeResolved
! !

