"
COPYRIGHT (c) 2020 LabWare
"
"{ Package: 'stx:goodies/ring/core/tests' }"

"{ NameSpace: Smalltalk }"

RGAbstractBehaviorTest subclass:#RGMetaclassTraitTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Tests-Core'
!

RGMetaclassTraitTest comment:''
!

!RGMetaclassTraitTest class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2020 LabWare


"
! !

!RGMetaclassTraitTest methodsFor:'as yet unclassified'!

behaviorClass

    ^ RGMetaclassTrait
!

testEnsureProtocol

    | behavior |
    
    behavior := self behaviorClass named: #SomeClass.
    behavior ensureProtocolNamed: #SomeProtocol.
    self assert: behavior protocols size equals: 1.
    self assert: behavior protocols first equals: #SomeProtocol.
    
! !

!RGMetaclassTraitTest methodsFor:'tests'!

testImplicitConversionFromClass

    | env |
    
    env := RGEnvironment new.
    env ensureClassNamed: #SomeTrait.
    self assert: (env ask behaviors select: [ :e | e name = #'SomeTrait' ]) size equals: 1.
    self assert: (env ask behaviors select: [ :e | e name = #'SomeTrait clss' ]) size equals: 0.
    
    env ensureTraitNamed: #'SomeTrait'.
    self assert: (env ask behaviors select: [ :e | e name = #'SomeTrait' ]) size equals: 1.
    self assert: (env ask behaviors select: [ :e | e name = #'SomeTrait classTrait' ]) size equals: 0.
    self assert: (env ask behaviors select: [ :e | e name = #'SomeTrait clss' ]) size equals: 0.
    env.
!

testImplicitConversionFromClassProperties

    | env entity |
    
    env := RGEnvironment new.
    entity := env ensureClassNamed: #SomeTrait.	
    entity := env ensureTraitNamed: #'SomeTrait'.
    self assert: entity classTrait isTrait.
    self assert: entity classTrait baseTrait equals: entity.
!

testMetaclassTraitImplicitEnvironment

    | trait |
    
    trait := RGMetaclassTrait unnamed.
    self assert: (trait hasUnresolved: #name).
    self checkImplicitSingleTraitEnvironmentOf: trait baseTrait.
    
    
    
    
!

testNewMetaclassTrait
    | trait baseTrait |
    trait := RGMetaclassTrait unnamed.
    self assert: trait isRingResolved.
    self assert: (trait hasUnresolved: #baseTrait).
    self assert: trait isTrait.

    baseTrait := RGTrait parent: trait environment.
    trait baseTrait: baseTrait.
    self assert: (trait hasResolved: #baseTrait).
    self assert: trait baseTrait identicalTo: baseTrait
! !

!RGMetaclassTraitTest class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

